-- 跳跳乐调试
Lua_JumpGameDebugWindow = class("Lua_JumpGameDebugWindow", Lua_Window);
Lua_JumpGameDebugWindow.Grid_Lift = 1;
Lua_JumpGameDebugWindow.Grid_Right = 2;
Lua_JumpGameDebugWindow.Grid_Random = 3;

Lua_JumpGameDebugWindow.Action_Idle = 0;-- 待机
Lua_JumpGameDebugWindow.Action_Jump_Pre = 100011; -- 下蹲
Lua_JumpGameDebugWindow.Action_Jump_Ready = 100012; -- 蓄力
Lua_JumpGameDebugWindow.Action_Jump_Up = 100013;-- 起跳
Lua_JumpGameDebugWindow.Action_Jump_Sky = 100014; -- 空中循环
Lua_JumpGameDebugWindow.Action_Jump_Down = 100015; -- 下落
Lua_JumpGameDebugWindow.Action_Jump_Success = 100017; -- 下落成功，下落缓冲
Lua_JumpGameDebugWindow.Action_Jump_Fail = 100016; --下落死亡

Lua_JumpGameDebugWindow.Action_Pre_To_Ready = 100020; -- 下蹲切蓄力
Lua_JumpGameDebugWindow.Action_Pre_To_Up = 100021; -- 下蹲切起跳
Lua_JumpGameDebugWindow.Action_Ready_To_Up = 100022; -- 蓄力切起跳
Lua_JumpGameDebugWindow.Action_Up_To_Sky = 100023; -- 起跳切空中
Lua_JumpGameDebugWindow.Action_Up_To_Down = 100024; -- 起跳切下落
Lua_JumpGameDebugWindow.Action_Sky_To_Down = 100025; -- 空中切下落
Lua_JumpGameDebugWindow.Action_Down_To_Success = 100026; -- 下落切成功
Lua_JumpGameDebugWindow.Action_Down_To_Fail = 100027; -- 下落切失败

Lua_JumpGameDebugWindow.Action_Idle_Time = 0.0;-- 待机时长
Lua_JumpGameDebugWindow.Action_Jump_Pre_Time = 2.0; -- 下蹲时长
Lua_JumpGameDebugWindow.Action_Jump_Ready_Time = 0.0; -- 蓄力时长
Lua_JumpGameDebugWindow.Action_Jump_Up_Time = 0.133;-- 起跳时长
Lua_JumpGameDebugWindow.Action_Jump_Sky_Time = 0.0; -- 空中循环时长
Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time = 0.26; -- 原地跳空中循环时长
Lua_JumpGameDebugWindow.Action_Jump_Down_Time = 0.267; -- 下落时长
Lua_JumpGameDebugWindow.Action_Jump_Success_Time = 0.7; -- 下落成功，下落缓冲时长
Lua_JumpGameDebugWindow.Action_Jump_Fail_Time = 0.667; --下落死亡时长

function Lua_JumpGameDebugWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.NORMAL_TOP_LAYER;
	self.windowName = "Lua_JumpGameDebugWindow";
	self.skinName = "JumpGameDebugWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.bInit = false;
	self.winBgPath = "/images/activities/xui_ttl_bg_3.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_JumpGameDebugWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.backBtn:setLocation(60, 770, 0);
	self.txtBg.mouseEnable = true;

	self._bOpenAssist = true;
	self.openAssist.selected = self._bOpenAssist;
	self.openAssist:addBoxChange(self, self.onOpenAssistChange);
	self.assistObj:SetActive(self._bOpenAssist);

	self._camField = 1.2;
	self._camIsOthro = true;
	self._camPos = Vector3.New(0, 4.01, -10);
	self._camRot = Vector3.New(21.662, 0, 0);
	local artifactVo = DataCenter.artifactUtil:getDefaultArtifact();
	self.modelItem = UICreate.createModelEffImg(self.jumpObj, artifactVo.modelUrl, artifactVo.modelSrc, 0, 0, 300, 300);
	self.modelItem:setCamField(self._camField, 0.01, 1000, self._camIsOthro);
	self.modelItem:setCamPos(self._camPos.x, self._camPos.y, self._camPos.z);
	self.modelItem:setCamRot(self._camRot.x, self._camRot.y, self._camRot.z);
	self.modelItem:addLuaAniCompleteFun(self, self.onModelAniComplete);
	self.modelItem.canRot = false;

	self.camPosXTxt.text = self._camPos.x .. "";
	self.camPosXTxt:onEndEdit(self, self.onCamPosXInputEnd);
	self.camPosYTxt.text = self._camPos.y .. "";
	self.camPosYTxt:onEndEdit(self, self.onCamPosYInputEnd);
	self.camPosZTxt.text = self._camPos.z .. "";
	self.camPosZTxt:onEndEdit(self, self.onCamPosZInputEnd);

	self.camRotXTxt.text = self._camRot.x .. "";
	self.camRotXTxt:onEndEdit(self, self.onCamRotXInputEnd);
	self.camRotYTxt.text = self._camRot.y .. "";
	self.camRotYTxt:onEndEdit(self, self.onCamRotYInputEnd);
	self.camRotZTxt.text = self._camRot.z .. "";
	self.camRotZTxt:onEndEdit(self, self.onCamRotZInputEnd);

	self.camFieldTxt.text = self._camField .. "";
	self.camFieldTxt:onEndEdit(self, self.onCamFieldInputEnd);

	self.camOrth.selected = self._camIsOthro;
	self.camPro.selected = not self._camIsOthro;
	self.camOrth:addBoxChange(self, self.onCamOrthChange);
	self.camPro:addBoxChange(self, self.onCamProChange);

	self._modelLiftDir = -60;
	self.liftDirYTxt.text = self._modelLiftDir .. "";
	self.liftDirYTxt:onEndEdit(self, self.onLiftDirInputEnd);

	self._modelRightDir = 25;
	self.rightDirYTxt.text = self._modelRightDir .. "";
	self.rightDirYTxt:onEndEdit(self, self.onRightDirInputEnd);

	self._curGridSize = 100;
	self.curGridTxt.text = self._curGridSize .. "";
	self.curGridTxt:addValidateInfo('0', '9');
	self.curGridTxt:onEndEdit(self, self.onCurGridInputEnd);

	self.gridNormalSize = 100;
	self.gridNorTxt.text = self.gridNormalSize .. "";
	self.gridNorTxt:addValidateInfo('0', '9');
	self.gridNorTxt:onEndEdit(self, self.onNormalSizeInputEnd);
	-- self.gridNorTxt:setEnable(false);
	-- self.gridNorBg:setEnable(false);
	-- self.gridNorTitle:setEnable(false);


	self._nextGridSize = 100;
	self.nextGridTxt.text = self._nextGridSize .. "";
	self.nextGridTxt:addValidateInfo('0', '9');
	self.nextGridTxt:onEndEdit(self, self.onNextGridInputEnd);

	self._nextGridDis = 50;
	self.nextDisTxt.text = self._nextGridDis .. "";
	self.nextDisTxt:addValidateInfo('0', '9');
	self.nextDisTxt:onEndEdit(self, self.onNextDisInputEnd);

	self._gridAngle = 60;
	self.angleTxt.text = self._gridAngle .. "";
	self.angleTxt:addValidateInfo('0', '9');
	self.angleTxt:onEndEdit(self, self.onAngleInputEnd);

	self._controllX = 0.65
	self.controllXTxt.text = self._controllX .. "";
	self.controllXTxt:onEndEdit(self, self.onControllXInputEnd);

	self._controllY = 1.15;
	self.controllYTxt.text = self._controllY .. "";
	self.controllYTxt:onEndEdit(self, self.onControllYInputEnd);

	self._spd = 350;
	self.spdTxt.text = self._spd .. "";
	self.spdTxt:onEndEdit(self, self.onSpdInputEnd);

	self._avoidTime = 10;
	self.avoidTxt.text = self._avoidTime .. "";
	self.avoidTxt:addValidateInfo('0', '9');
	self.avoidTxt:onEndEdit(self, self.onAvoidInputEnd);

	self._jumpOrginY = 350;
	self.orginYTxt.text = self._jumpOrginY .. "";
	self.orginYTxt:onEndEdit(self, self.onOrginYInputEnd);

	self._imitateTime = 25;
	self.pressTime = self._imitateTime / 30;
	self.imitateTxt.text = self._imitateTime .. "";
	self.imitateTxt:addValidateInfo('0', '9');
	self.imitateTxt:onEndEdit(self, self.onImitateInputEnd);

	self.tipsStr = "";
	self.tipsTxt.text = "";
	self.circleBox.selected = true;
	self._routeTimeRate = 0.5;
	self.playSpdTxt.text = self._routeTimeRate .. "";
	self.playSpdTxt:onEndEdit(self, self.onPlaySpdInputEnd);

	self._maxDownTime = 10;
	self.playSpd2Txt.text = self._maxDownTime .. "";
	self.playSpd2Txt:onEndEdit(self, self.onPlaySpd2InputEnd);

	self._maxRouteTime = 18;
	self.playSpd3Txt.text = self._maxRouteTime .. "";
	self.playSpd3Txt:onEndEdit(self, self.onPlaySpd3InputEnd);

	self._originSkyTime = Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time;
	self.orginSkyTimeTxt.text = self._originSkyTime .. "";
	self.orginSkyTimeTxt:onEndEdit(self, self.onOriginSkyTimeInputEnd);

	self.maxPressItemCount = 10;

	self.winBg:addMousDownFuntion(self, self.onMouseDownHandle);
	self.winBg:addMouseUpFuntion(self, self.onMouseUpHandle);
	self.playBtn:addClickFuntion(self, self.onPlayBtnHandler);
	self.dirLift:addBoxChange(self, self.onDirLiftChange);
	self.dirRight:addBoxChange(self, self.onDirRightChange);
	self.dirRandom:addBoxChange(self, self.onDirRandomChange);

	self.bInit = true;
	self:selectDir(Lua_JumpGameDebugWindow.Grid_Random);
end

function Lua_JumpGameDebugWindow:dispose()
	self:endCalPressTime();
	self:endModelMove();

	if self.bImitateTimer then
		self.bImitateTimer = false;
		self:removeTimer(self, self.onImitateTimer);
	end

	if self._segmentPointArr ~= nil then
		self._segmentPointArr:dispose();
		self._segmentPointArr:clear();
		self._segmentPointArr = nil;
	end

	if self._idleSegmentPointArr ~= nil then
		self._idleSegmentPointArr:dispose();
		self._idleSegmentPointArr:clear();
		self._idleSegmentPointArr = nil;
	end

	self.modelItem.alpha = 1;
	TweenUtil.getInstance():stop(self.modelItem);
	TweenUtil.getInstance():stop(self.jumpObj);
	TweenUtil.getInstance():stop(self.assistObj);
	self:superCall("dispose");
end

function Lua_JumpGameDebugWindow:onOpenAssistChange(state)
	self._bOpenAssist = state;
	self.assistObj:SetActive(self._bOpenAssist);
	self:generateAssist();
end

function Lua_JumpGameDebugWindow:onCamPosXInputEnd()
	local str = self.camPosXTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camPosXTxt.text = self._camPos.x .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camPosXTxt.text = self._camPos.x .. "";
    	return;
    end
    self._camPos.x = num;
    self.modelItem:setCamPos(self._camPos.x, self._camPos.y, self._camPos.z);
end

function Lua_JumpGameDebugWindow:onCamPosYInputEnd()
	local str = self.camPosYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camPosYTxt.text = self._camPos.y .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camPosYTxt.text = self._camPos.y .. "";
    	return;
    end
    self._camPos.y = num;
    self.modelItem:setCamPos(self._camPos.x, self._camPos.y, self._camPos.z);
end

function Lua_JumpGameDebugWindow:onCamPosZInputEnd()
	local str = self.camPosZTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camPosZTxt.text = self._camPos.z .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camPosZTxt.text = self._camPos.z .. "";
    	return;
    end
    self._camPos.z = num;
    self.modelItem:setCamPos(self._camPos.x, self._camPos.y, self._camPos.z);
end

function Lua_JumpGameDebugWindow:onCamRotXInputEnd()
	local str = self.camRotXTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camRotXTxt.text = self._camRot.x .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camRotXTxt.text = self._camRot.x .. "";
    	return;
    end
    self._camRot.x = num;
    self.modelItem:setCamRot(self._camRot.x, self._camRot.y, self._camRot.z);
end

function Lua_JumpGameDebugWindow:onCamPosYInputEnd()
	local str = self.camRotYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camRotYTxt.text = self._camRot.y .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camRotYTxt.text = self._camRot.y .. "";
    	return;
    end
    self._camRot.y = num;
    self.modelItem:setCamRot(self._camRot.x, self._camRot.y, self._camRot.z);
end

function Lua_JumpGameDebugWindow:onCamPosZInputEnd()
	local str = self.camRotZTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camRotZTxt.text = self._camRot.z .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camRotZTxt.text = self._camRot.z .. "";
    	return;
    end
    self._camRot.z = num;
    self.modelItem:setCamRot(self._camRot.x, self._camRot.y, self._camRot.z);
end

function Lua_JumpGameDebugWindow:onCamFieldInputEnd()
	local str = self.camFieldTxt.text;
    if strIsNullOrEmpty(str) then
    	self.camFieldTxt.text = self._camField .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.camFieldTxt.text = self._camField .. "";
    	return;
    end
    self._camField = num;
    self.modelItem:setCamField(self._camField, 0.01, 1000, self._camIsOthro);
end

function Lua_JumpGameDebugWindow:onCamOrthChange(state)
	if state and not self._camIsOthro then
		self._camIsOthro = true;
		self.modelItem:setCamField(self._camField, 0.01, 1000, self._camIsOthro);
	end
	self.camOrth.selected = self._camIsOthro;
	self.camPro.selected = not self._camIsOthro;
end

function Lua_JumpGameDebugWindow:onCamProChange(state)
	if state and self._camIsOthro then
		self._camIsOthro = false;
		self.modelItem:setCamField(self._camField, 0.01, 1000, self._camIsOthro);
	end
	self.camOrth.selected = self._camIsOthro;
	self.camPro.selected = not self._camIsOthro;
end

function Lua_JumpGameDebugWindow:onLiftDirInputEnd()
    local str = self.liftDirYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.liftDirYTxt.text = self._modelLiftDir .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil then
    	self.liftDirYTxt.text = self._modelLiftDir .. "";
    	return;
    end
    self._modelLiftDir = num;
    self:refreshModelDir();
end

function Lua_JumpGameDebugWindow:onRightDirInputEnd()
    local str = self.rightDirYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.rightDirYTxt.text = self._modelRightDir .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil then
    	self.rightDirYTxt.text = self._modelRightDir .. "";
    	return;
    end
    self._modelRightDir = num;
    self:refreshModelDir();
end

function Lua_JumpGameDebugWindow:onCurGridInputEnd()
    local str = self.curGridTxt.text;
    if strIsNullOrEmpty(str) then
    	self.curGridTxt.text = self._curGridSize .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.curGridTxt.text = self._curGridSize .. "";
    	return;
    end
    self._curGridSize = num;
    self:refreshCurGrid();
end

function Lua_JumpGameDebugWindow:onNormalSizeInputEnd()
	local str = self.gridNorTxt.text;
    if strIsNullOrEmpty(str) then
    	self.gridNorTxt.text = self.gridNormalSize .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.gridNorTxt.text = self.gridNormalSize .. "";
    	return;
    end

    self.gridNormalSize = num;
    self:refreshCurGrid();
    self:refreshNextGrid();
end

function Lua_JumpGameDebugWindow:onNextGridInputEnd()
    local str = self.nextGridTxt.text;
    if strIsNullOrEmpty(str) then
    	self.nextGridTxt.text = self._nextGridSize .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.nextGridTxt.text = self._nextGridSize .. "";
    	return;
    end
    self._nextGridSize = num;
    self:refreshNextGrid();
end

function Lua_JumpGameDebugWindow:onNextDisInputEnd()
    local str = self.nextDisTxt.text;
    if strIsNullOrEmpty(str) then
    	self.nextDisTxt.text = self._nextGridDis .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.nextDisTxt.text = self._nextGridDis .. "";
    	return;
    end
    self._nextGridDis = num;
    self:refreshNextGrid();
    self:generateAssist();
end

function Lua_JumpGameDebugWindow:onAngleInputEnd()
    local str = self.angleTxt.text;
    if strIsNullOrEmpty(str) then
    	self.angleTxt.text = self._gridAngle .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.angleTxt.text = self._gridAngle .. "";
    	return;
    end
    self._gridAngle = num;
    self:refreshNextGrid();
    self:generateAssist();
end

function Lua_JumpGameDebugWindow:onDirLiftChange(state)
	if state and self.dirType ~= Lua_JumpGameDebugWindow.Grid_Lift then
		self:selectDir(Lua_JumpGameDebugWindow.Grid_Lift);
	else
		self.dirLift.selected = true;
	end
end

function Lua_JumpGameDebugWindow:onDirRightChange(state)
	if state and self.dirType ~= Lua_JumpGameDebugWindow.Grid_Right then
		self:selectDir(Lua_JumpGameDebugWindow.Grid_Right);
	else
		self.dirRight.selected = true;
	end
end

function Lua_JumpGameDebugWindow:onDirRandomChange(state)
	if state and self.dirType ~= Lua_JumpGameDebugWindow.Grid_Random then
		self:selectDir(Lua_JumpGameDebugWindow.Grid_Random);
	else
		self.dirRandom.selected = true;
	end
end

function Lua_JumpGameDebugWindow:onControllXInputEnd()
	local str = self.controllXTxt.text;
    if strIsNullOrEmpty(str) then
    	self.controllXTxt.text = self._controllX .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.controllXTxt.text = self._controllX .. "";
    	return;
    end
    self._controllX = num;
    self:generateAssist();
end

function Lua_JumpGameDebugWindow:onControllYInputEnd()
	local str = self.controllYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.controllYTxt.text = self._controllY .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.controllYTxt.text = self._controllY .. "";
    	return;
    end
    self._controllY = num;
    self:generateAssist();
end

function Lua_JumpGameDebugWindow:onSpdInputEnd()
	local str = self.spdTxt.text;
    if strIsNullOrEmpty(str) then
    	self.spdTxt.text = self._spd .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.spdTxt.text = self._spd .. "";
    	return;
    end
    self._spd = num;
    self:generateRouteAssist(self.pressTime);
end

function Lua_JumpGameDebugWindow:onAvoidInputEnd()
	local str = self.avoidTxt.text;
    if strIsNullOrEmpty(str) then
    	self.avoidTxt.text = self._avoidTime .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.avoidTxt.text = self._avoidTime .. "";
    	return;
    end
    self._avoidTime = num;
end

function Lua_JumpGameDebugWindow:onOrginYInputEnd()
	local str = self.orginYTxt.text;
    if strIsNullOrEmpty(str) then
    	self.orginYTxt.text = self._jumpOrginY .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.orginYTxt.text = self._jumpOrginY .. "";
    	return;
    end
    self._jumpOrginY = num;
end

function Lua_JumpGameDebugWindow:onImitateInputEnd()
	local str = self.imitateTxt.text;
    if strIsNullOrEmpty(str) then
    	self.imitateTxt.text = self._imitateTime .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.imitateTxt.text = self._imitateTime .. "";
    	return;
    end
    self._imitateTime = num;
    self.pressTime = num / 30;
    self:generateRouteAssist(self.pressTime);
end

function Lua_JumpGameDebugWindow:onPlaySpdInputEnd()
	local str = self.playSpdTxt.text;
    if strIsNullOrEmpty(str) then
    	self.playSpdTxt.text = self._routeTimeRate .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.playSpdTxt.text = self._routeTimeRate .. "";
    	return;
    end
    self._routeTimeRate = num;
end

function Lua_JumpGameDebugWindow:onPlaySpd2InputEnd()
	local str = self.playSpd2Txt.text;
    if strIsNullOrEmpty(str) then
    	self.playSpd2Txt.text = self._maxDownTime .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.playSpd2Txt.text = self._maxDownTime .. "";
    	return;
    end
    self._maxDownTime = num;
end

function Lua_JumpGameDebugWindow:onPlaySpd3InputEnd()
	local str = self.playSpd3Txt.text;
    if strIsNullOrEmpty(str) then
    	self.playSpd3Txt.text = self._maxRouteTime .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.playSpd3Txt.text = self._maxRouteTime .. "";
    	return;
    end
    self._maxRouteTime = num;
end

function Lua_JumpGameDebugWindow:onOriginSkyTimeInputEnd()
	local str = self.orginSkyTimeTxt.text;
    if strIsNullOrEmpty(str) then
    	self.orginSkyTimeTxt.text = self._originSkyTime .. "";
    	return;
    end
    local num = tonumber(str);
    if num == nil or num <= 0 then
    	self.orginSkyTimeTxt.text = self._originSkyTime .. "";
    	return;
    end
    self._originSkyTime = num;
    Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time = self._originSkyTime;
end

function Lua_JumpGameDebugWindow:selectDir(dirTy)
	if not self.bInit then 
		return; 
	end

	if dirTy == Lua_JumpGameDebugWindow.Grid_Lift then
		self.dir = Lua_JumpGameDebugWindow.Grid_Lift;
	elseif dirTy == Lua_JumpGameDebugWindow.Grid_Right then
		self.dir = Lua_JumpGameDebugWindow.Grid_Right;
	else
		self.dir = (Mathf.Random(0, 100) > 50) and Lua_JumpGameDebugWindow.Grid_Right or Lua_JumpGameDebugWindow.Grid_Lift;
	end

	self.dirType = dirTy;
	self.dirLift.selected = dirTy == Lua_JumpGameDebugWindow.Grid_Lift;
	self.dirRight.selected = dirTy == Lua_JumpGameDebugWindow.Grid_Right;
	self.dirRandom.selected = dirTy == Lua_JumpGameDebugWindow.Grid_Random;
	self.bLeft = self.dir == Lua_JumpGameDebugWindow.Grid_Lift;
	self:refreshCurGrid();
	self:refreshModelDir();
	self:refreshNextGrid();
	self:generateAssist();
end

-- 刷新浣熊朝向
function Lua_JumpGameDebugWindow:refreshModelDir()
	if self.curGridPos == nil then
		self.curGridPos = Vector2.New(0, 0);
	end

	local px = self.curGridPos.x;
	local py = 720 - self.curGridPos.y + 200;
	if self.dir == Lua_JumpGameDebugWindow.Grid_Lift then
		self.modelItem:setModelEffDir(self._modelLiftDir);
		if px > 0 then
			px = -px + 150;
		else
			px = -px + 150;
		end
	else
		self.modelItem:setModelEffDir(self._modelRightDir);
		if px > 0 then
			px = -px - 150;
		else
			px = -px - 150
		end
	end

	if self.lastJumpObjPos ~= nil then
		TweenUtil.getInstance():stop(self.jumpObj);
		TweenUtil.getInstance():stop(self.assistObj);
		LuaUtil.setObjPos(self.jumpObj, self.lastJumpObjPos.x, self.lastJumpObjPos.y, 0);
		LuaUtil.setObjPos(self.assistObj, self.lastJumpObjPos.x, self.lastJumpObjPos.y, 0);
	end

	if self.lastJumpObjPos ~= nil and self.lastJumpObjPos.x ~= px and self.lastJumpObjPos.y ~= py then
		TweenUtil.getInstance():addTweenTargetPos(self.jumpObj, 0.5, 0, px, py, 0);
		TweenUtil.getInstance():addTweenTargetPos(self.assistObj, 0.5, 0, px, py, 0);
	else
		if self.lastJumpObjPos == nil then
			self.lastJumpObjPos = Vector2.New(px, py);
		else
			self.lastJumpObjPos:Set(px, py);
		end
		LuaUtil.setObjPos(self.jumpObj, px, py, 0);
		LuaUtil.setObjPos(self.assistObj, px, py, 0);
	end
end

function Lua_JumpGameDebugWindow:refreshNextGrid()
	local nx = (self._nextGridDis + self._curGridSize + self._nextGridSize) * Mathf.Sin(Mathf.Rad(self._gridAngle));
	local ny = (self._nextGridDis + self._curGridSize + self._nextGridSize) * Mathf.Cos(Mathf.Rad(self._gridAngle));
	if self.dir == Lua_JumpGameDebugWindow.Grid_Lift then
		nx = self.curGridPos.x - nx;
	else
		nx = self.curGridPos.x + nx;
	end

	ny = self.curGridPos.y + ny;
	if self.nextGridPos == nil then
		self.nextGridPos = Vector2.New(nx, ny);
	else
		self.nextGridPos:Set(nx, ny);
	end

	local bw = (self._nextGridSize / self.gridNormalSize) * 240;
	local bh = (self._nextGridSize / self.gridNormalSize) * 200;
	if self.nextGridItem == nil then
		self.nextGridItem = UICreate.createUIAtlasImage(self.jumpObj, "jump_happy_atlas", "xui_ttl_widget_20", self.nextGridPos.x, self.nextGridPos.y - 30, bw, bh);
	else
		self.nextGridItem:SetDimensions(bw, bh);
		self.nextGridItem:setLocation(self.nextGridPos.x, self.nextGridPos.y - 30);	
	end
	self.nextGridItem.siblingIndex = 0;
end

-- 刷新格子
function Lua_JumpGameDebugWindow:refreshCurGrid()
	if self.curGridPos == nil then
		self.curGridPos = Vector2.New(0, 0);
	end

	if self.curModelPos == nil then
		self.curModelPos = Vector2(self.curGridPos.x, self.curGridPos.y);
	end

	local bw = (self._curGridSize / self.gridNormalSize) * 240;
	local bh = (self._curGridSize / self.gridNormalSize) * 200;
	if self.curGridItem == nil then
		self.curGridItem = UICreate.createUIAtlasImage(self.jumpObj, "jump_happy_atlas", "xui_ttl_widget_20", self.curGridPos.x, self.curGridPos.y - 30, bw, bh);
		self.curGridItem.siblingIndex = 0;
	else
		self.curGridItem:SetDimensions(bw, bh);
		self.curGridItem:setLocation(self.curGridPos.x, self.curGridPos.y - 30);	
	end

	self.modelItem:setLocation(self.curModelPos.x, self.curModelPos.y);	
end

-- 生成辅助线
function Lua_JumpGameDebugWindow:generateAssist()
	if not self._bOpenAssist then
		return;
	end

	if self.curGridPos == nil then
		self.curGridPos = Vector2.New(0, 0);
	end

	if self.hLineAssistItem == nil then
		self.hLineAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "xui_common_itembg_6", self.curGridPos.x, self.curGridPos.y, 1200, 2);
	else
		self.hLineAssistItem:setLocation(self.curGridPos.x, self.curGridPos.y);	
	end

	if self.vLineAssistItem == nil then
		self.vLineAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "xui_common_itembg_6", self.nextGridPos.x, self.nextGridPos.y, 2, 1200);
	else
		self.vLineAssistItem:setLocation(self.nextGridPos.x, self.nextGridPos.y);	
	end

	if self.xLineAssistItem == nil then
		self.xLineAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "xui_common_itembg_6", self.nextGridPos.x, self.nextGridPos.y, 2, 1200);
	else
		self.xLineAssistItem:setLocation(self.nextGridPos.x, self.nextGridPos.y);	
	end
	self.xLineAssistItem:setRot(0, 0, (self.dir == Lua_JumpGameDebugWindow.Grid_Lift) and self._gridAngle or -self._gridAngle);

	if self.curGridAssistItem == nil then
		self.curGridAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "ui_liaotian_button_009_n", self.curGridPos.x, self.curGridPos.y, 12, 12);
	else
		self.curGridAssistItem:setLocation(self.curGridPos.x, self.curGridPos.y);	
	end

	if self.nextGridAssistItem == nil then
		self.nextGridAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "ui_liaotian_button_009_n", self.nextGridPos.x, self.nextGridPos.y, 12, 12);
	else
		self.nextGridAssistItem:setLocation(self.nextGridPos.x, self.nextGridPos.y);	
	end

	self:generateRouteAssist(self.pressTime);
end

function Lua_JumpGameDebugWindow:checkValidPress()
	if self._bplayingJump then
		return;
	end

	return true;
end

function Lua_JumpGameDebugWindow:onMouseDownHandle()
	if self:checkValidPress() ~= true then
		return;
	end

	if self.curModelPos == nil then
		self.curModelPos = Vector2(self.curGridPos.x, self.curGridPos.y);
	end

	self:startCalPressTime();

	-- self.pressTime = 0; -- 按压时长
	-- self.lastMouseDownTime = getTime();
	-- self.startMouseDownTime = getTime();
	-- self.playJumpPre = Lua_JumpGameDebugWindow.Action_Jump_Pre_Time;
	-- self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Jump_Pre, -1);
	-- self.lastModelAct = Lua_JumpGameDebugWindow.Action_Jump_Pre;
	-- self.tipsStr = "开始按压\n播放" .. self:getActionName(self.lastModelAct) .. "(" .. self.lastModelAct .. ")动作，下蹲动作最大时长：".. string.format("%.2f", self.playJumpPre);
	-- self.tipsTxt.text = self.tipsStr;
	-- if not self.bPressTimer then
	-- 	self.bPressTimer = true;
	-- 	self:addTimer("Lua_JumpGameDebugWindow_onPress", 0.01, self, self.onPressTimer, nil, -1);
	-- end
end

function Lua_JumpGameDebugWindow:startCalPressTime()
	if self.bPressTimer ~= true then
		self.bPressTimer = true;

		self.pressTime = 0;
		self.lastMouseDownTime = getTime();
		self.startMouseDownTime = getTime();
		self.playJumpPre = Lua_JumpGameDebugWindow.Action_Jump_Pre_Time;
		self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Jump_Pre, -1);
		self.lastModelAct = Lua_JumpGameDebugWindow.Action_Jump_Pre;

		self.tipsStr = "开始按压\n播放" .. self:getActionName(self.lastModelAct) .. "(" .. self.lastModelAct .. ")动作，下蹲动作最大时长：".. string.format("%.2f", self.playJumpPre);
		self.tipsTxt.text = self.tipsStr;

		self:addTimer("Lua_JumpGameDebugWindow_onPress", 0.01, self, self.onPressTimer, nil, -1, true);
		self:onPressTimer();
	end
end

function Lua_JumpGameDebugWindow:onPressTimer()
	self.pressTime = getTime() - self.startMouseDownTime; -- 按压时长
	if self.playJumpPre > 0 then
		local t = getTime();
		local dt = t - self.lastMouseDownTime;
		self.lastMouseDownTime = t;
		self.playJumpPre = self.playJumpPre - dt;
		if self.playJumpPre <= 0 then -- 切换到蓄力循环
			self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Pre_To_Ready, -1);
			self.lastModelAct = Lua_JumpGameDebugWindow.Action_Pre_To_Ready;
			self.tipsStr = self.tipsStr .. "\n播放" .. self:getActionName(self.lastModelAct) .. "(" .. self.lastModelAct .. ")动作，当前按压时长：" .. string.format("%.2f", self.pressTime);
			self.tipsTxt.text = self.tipsStr;
		end
	end

	self:generateRouteAssist(self.pressTime);
end

function Lua_JumpGameDebugWindow:endCalPressTime()
	if self.bPressTimer then
		self.bPressTimer = false;
		self:removeTimer(self, self.onPressTimer);
	end
end

function Lua_JumpGameDebugWindow:onMouseUpHandle()
	if self._bplayingJump then
		return;
	end

	if self:checkShowAssistLine() ~= true then
		self:calJumpControllPos(self.pressTime);
	end
	self:endCalPressTime(); 

	self.pressTime = getTime() - self.startMouseDownTime; -- 按压时长
	self.tipsStr = self.tipsStr .. "\n按压结束，按压总时长：" .. string.format("%.2f", self.pressTime);
	self.tipsTxt.text = self.tipsStr;
	self:generateRouteAssist(self.pressTime);
	self:playingJump(self.pressTime); 
end

function Lua_JumpGameDebugWindow:onPlayBtnHandler()
	if self._bplayingJump then
		return;
	end

	self.pressTime = self._imitateTime / 30;
	self:imitateJumpOperate();
end

-- 模拟跳跃操作，要先模拟按下，再模拟起跳过程
function Lua_JumpGameDebugWindow:imitateJumpOperate()
	if self.pressTime == nil or self.pressTime <= 0 then
		if self.bImitateTimer then
			self.bImitateTimer = false;
			self:removeTimer(self, self.onImitateTimer);
		end
		return;
	end

	self.lastMouseDownTime = getTime();
	self.startMouseDownTime = getTime();
	self.playJumpPre = Lua_JumpGameDebugWindow.Action_Jump_Pre_Time;
	self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Jump_Pre, -1);
	self.lastModelAct = Lua_JumpGameDebugWindow.Action_Jump_Pre;
	self.tipsStr = "开始按压\n播放" .. self:getActionName(self.lastModelAct) .. "(" .. self.lastModelAct .. ")动作，下蹲动作最大时长：" .. string.format("%.2f", self.playJumpPre);
	self.tipsTxt.text = self.tipsStr;
	if not self.bImitateTimer then
		self.bImitateTimer = true;
		self:addTimer("Lua_JumpGameDebugWindow_onImitate", 0.01, self, self.onImitateTimer, nil, -1);
	end
end

function Lua_JumpGameDebugWindow:onImitateTimer()
	local t = getTime();
	if self.playJumpPre > 0 then
		local dt = t - self.lastMouseDownTime;
		self.lastMouseDownTime = t;
		self.playJumpPre = self.playJumpPre - dt;
		if self.playJumpPre <= 0 then -- 切换到蓄力循环
			self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Pre_To_Ready, -1);
			self.lastModelAct = Lua_JumpGameDebugWindow.Action_Pre_To_Ready;
			self.tipsStr = self.tipsStr .. "\n播放" .. self:getActionName(self.lastModelAct) .. "(" .. self.lastModelAct .. ")动作，当前按压时长：" .. string.format("%.2f", (t - self.startMouseDownTime));
			self.tipsTxt.text = self.tipsStr;
		end
	end

	self:generateRouteAssist(t - self.startMouseDownTime);
	if self.pressTime <= t - self.startMouseDownTime then -- 结束按压
		if self.bImitateTimer then
			self.bImitateTimer = false;
			self:removeTimer(self, self.onImitateTimer);
		end

		self.tipsStr = self.tipsStr .. "\n按压结束，按压总时长：" .. string.format("%.2f", self.pressTime);
		self.tipsTxt.text = self.tipsStr;
		self:playingJump(self.pressTime);
	end
end

function Lua_JumpGameDebugWindow:checkShowAssistLine()
	return self._bOpenAssist;
end

function Lua_JumpGameDebugWindow:calJumpControllPos(dt)
	local dis = self._spd * self.pressTime;

	local angle = MathUtil.getDirectionByXY(self.nextGridPos.x, self.nextGridPos.y, self.curModelPos.x, self.curModelPos.y);
	if self.bLeft then
		angle = 90 + angle;
	else
		angle = -angle - 90;
	end
	local nx = dis * Mathf.Sin(Mathf.Rad(angle));
	local ny = dis * Mathf.Cos(Mathf.Rad(angle));
	if self.bLeft then
		nx = self.curModelPos.x - nx;
	else
		nx = self.curModelPos.x + nx;
	end

	ny = self.curModelPos.y + ny;
	if self.targetJumpPos == nil then
		self.targetJumpPos = Vector2.New(nx, ny);
	else
		self.targetJumpPos:Set(nx, ny);
	end

	-- 控制点
	local dw = 0;
	local cx = 0;
	if self.targetJumpPos.x > 0 and self.curModelPos.x < 0 then
		dw = Mathf.Abs(self.curModelPos.x) + self.targetJumpPos.x;
	elseif self.targetJumpPos.x < 0 and self.curModelPos.x > 0 then
		dw = Mathf.Abs(self.targetJumpPos.x) + self.curModelPos.x;
	else
		dw = Mathf.Abs(self.targetJumpPos.x - self.curModelPos.x);
	end
	if not self.bLeft then
		cx = dw * self._controllX + self.curModelPos.x;
	else
		cx = -dw * self._controllX + self.curModelPos.x;
	end
	local cy = dis * self._controllY + self.targetJumpPos.y;
	if self.jumpControllPos == nil then
		self.jumpControllPos = Vector2.New(cx, cy);
	else
		self.jumpControllPos:Set(cx, cy);
	end
end

function Lua_JumpGameDebugWindow:getBezierLinePointByIndex(index)
	if self.bezierLinePoints == nil then
		self.bezierLinePoints = {};
	end

	local item = self.bezierLinePoints[index];
	if item == nil then
		item = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "ui_liaotian_button_009_n", 0, 0, 12, 12);
		self.bezierLinePoints[index] = item;
	end

	return item;
end

-- 路径辅助线
function Lua_JumpGameDebugWindow:generateRouteAssist(dt)
	if self:checkShowAssistLine() ~= true then
		return; 
	end

	if self.curModelPos == nil then
		self.curModelPos = Vector2(self.curGridPos.x, self.curGridPos.y);
	end

	self:calJumpControllPos(dt);

	-- 控制点
	if self.controllPointAssistItem == nil then
		self.controllPointAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "ui_liaotian_button_009_n", self.jumpControllPos.x, self.jumpControllPos.y, 12, 12);
	else
		self.controllPointAssistItem:setLocation(self.jumpControllPos.x, self.jumpControllPos.y);	
	end

	if self.controllPointVAssistItem == nil then
		self.controllPointVAssistItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "xui_common_itembg_6", self.jumpControllPos.x, self.jumpControllPos.y, 2, 2000);
	else
		self.controllPointVAssistItem:setLocation(self.jumpControllPos.x, self.jumpControllPos.y);	
	end

	-- 轨迹点
	local t;
	local pos = Vector2(0, 0);
	local item;
	for i = 1, self.maxPressItemCount do
		t = 1 / self.maxPressItemCount * i;
		pos = Lua_BezierUtils.Calculate2DimensionalBezierPoint(t , self.curModelPos, self.jumpControllPos, self.targetJumpPos, pos);
		item = self:getBezierLinePointByIndex(i);
		item:setLocation(pos.x, pos.y);
		item:setEnable(true);
	end
	-- local segmentNum = (dis / 250) * 20;
	-- local arr = Lua_BezierUtils.Get2DBeizerList(self.curModelPos, self.jumpControllPos, self.targetJumpPos, segmentNum);
	-- if self._segmentPointArr == nil then
	-- 	self._segmentPointArr = Array();
	-- end
	-- if self._idleSegmentPointArr == nil then
	-- 	self._idleSegmentPointArr = Array();
	-- end

	-- local arrLen = arr:getSize();
	-- while (self._segmentPointArr:getSize() > arrLen) do
	-- 	local pointItem = self._segmentPointArr:remove();
	-- 	pointItem:setEnable(false);
	-- 	self._idleSegmentPointArr:add(pointItem);
	-- end

	-- for i = 1, arr:getSize() do
	-- 	local v = arr[i];
	-- 	local pointItem = self._segmentPointArr[i];
	-- 	if pointItem == nil then
	-- 		if self._idleSegmentPointArr:getSize() > 0 then
	-- 			pointItem = self._idleSegmentPointArr:remove();
	-- 			pointItem:setLocation(v.x, v.y);	
	-- 			pointItem:setEnable(true);
	-- 		else
	-- 			pointItem = UICreate.createUIAtlasImage(self.assistObj, "common_altas_1", "ui_liaotian_button_009_n", v.x, v.y, 12, 12);
	-- 		end
	-- 		self._segmentPointArr:add(pointItem);
	-- 	else
	-- 		pointItem:setLocation(v.x, v.y);	
	-- 	end
	-- end
end

function Lua_JumpGameDebugWindow:playingJump(dt)
	if self._bplayingJump then
		return;
	end

	if dt == nil then
		return;
	end

	if self.actionArr == nil then
		self.actionArr = Array();
	else
		self.actionArr:clear();
	end

	if self.actionTimeArr == nil then
		self.actionTimeArr = Array();
	else
		self.actionTimeArr:clear();
	end

	-- 假设用贝塞尔曲线处理，以下逻辑思考
	-- 影响因子：目标点、运动轨迹时长、控制点
	-- 目标点计算,self.targetJumpPos，确定受按压时长影响, 
	-- 运动轨迹时长计算,self.jumpRouteTime，确定受按压时长、必做动作时长影响
	-- 控制点计算,self.jumpControllPos，确定受按压时长影响
	-- 【动作时长】和【路径过程时长】，【路径过程时】长一定要大于【必做的动作时长】
	local routeTime = 0; -- 路径过程时长
	local actionTime = 0; -- 动作时长
	-- 必做的动作时长，起跳 + 下落，注意：下蹲和蓄力在按压阶段就做完了
	local normalTime = Lua_JumpGameDebugWindow.Action_Jump_Up_Time + Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time + Lua_JumpGameDebugWindow.Action_Jump_Down_Time;  
	if dt <= self._avoidTime / 30 then -- 防误触，原地跳，normalTime + 下落成功
		actionTime = normalTime + Lua_JumpGameDebugWindow.Action_Jump_Success_Time;
		routeTime = normalTime;

		self.jumpControllPos:Set(self.curModelPos.x, self.curModelPos.y + self._jumpOrginY);
		self.targetJumpPos:Set(self.curModelPos.x, self.curModelPos.y);

		if self.lastModelAct == Lua_JumpGameDebugWindow.Action_Pre_To_Ready then
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Ready_To_Up);
		else
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Pre_To_Up);
		end
		self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Up_Time);

		self.actionArr:add(Lua_JumpGameDebugWindow.Action_Up_To_Sky);
		self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time);

		self.actionArr:add(Lua_JumpGameDebugWindow.Action_Sky_To_Down);
		self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Down_Time);

		self.actionArr:add(Lua_JumpGameDebugWindow.Action_Down_To_Success);
		self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Success_Time);

		self.tipsStr = self.tipsStr .. "\n触发防误触，播放原地跳过程，跳跃路径时长：" .. string.format("%.2f", routeTime);
		self.tipsTxt.text = self.tipsStr;
	else
		-- -- 起点到目标点的跳跃时长不能直接采用dt去处理，探索下不同的路径过程时长的计算方式
		-- local dis = self._spd * dt; -- 该跳跃目标点的距离计算公式影响按压难度的判断，考虑尝试不同的
		-- self.tipsStr = self.tipsStr .. "\n跳跃距离：" .. string.format("%.2f", dis);
		-- local angle = MathUtil.getDirectionByXY(self.nextGridPos.x, self.nextGridPos.y, self.curModelPos.x, self.curModelPos.y);
		-- if self.dir == Lua_JumpGameDebugWindow.Grid_Lift then
		-- 	angle = 90 + angle;
		-- else
		-- 	angle = -angle - 90;
		-- end
		-- local nx = dis * Mathf.Sin(Mathf.Rad(angle));
		-- local ny = dis * Mathf.Cos(Mathf.Rad(angle));
		-- if self.dir == Lua_JumpGameDebugWindow.Grid_Lift then
		-- 	nx = self.curModelPos.x - nx;
		-- else
		-- 	nx = self.curModelPos.x + nx;
		-- end

		-- ny = self.curModelPos.y + ny;
		-- if self.targetJumpPos == nil then
		-- 	self.targetJumpPos = Vector2.New(nx, ny);
		-- else
		-- 	self.targetJumpPos:Set(nx, ny);
		-- end

		-- -- 控制点
		-- local dw = 0;
		-- local cx = 0;
		-- if self.targetJumpPos.x > 0 and self.curModelPos.x < 0 then
		-- 	dw = Mathf.Abs(self.curModelPos.x) + self.targetJumpPos.x;
		-- elseif self.targetJumpPos.x < 0 and self.curModelPos.x > 0 then
		-- 	dw = Mathf.Abs(self.targetJumpPos.x) + self.curModelPos.x;
		-- else
		-- 	dw = Mathf.Abs(self.targetJumpPos.x - self.curModelPos.x);
		-- end
		-- if self.dir == Lua_JumpGameDebugWindow.Grid_Right then
		-- 	cx = dw * self._controllX + self.curModelPos.x;
		-- else
		-- 	cx = -dw * self._controllX + self.curModelPos.x;
		-- end
		-- local cy = dis * self._controllY + self.targetJumpPos.y;
		-- if self.jumpControllPos == nil then
		-- 	self.jumpControllPos = Vector2.New(cx, cy);
		-- else
		-- 	self.jumpControllPos:Set(cx, cy);
		-- end

		-- 运动轨迹时长
		if dt > self._maxDownTime / 30 then
			routeTime = self._maxRouteTime / 30;
		else
			routeTime = dt * self._routeTimeRate;
		end
		if routeTime < normalTime then
			routeTime = normalTime;
		end

		if self.lastModelAct == Lua_JumpGameDebugWindow.Action_Pre_To_Ready then
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Ready_To_Up);
		else
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Pre_To_Up);
		end
		self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Up_Time);

		local skyTime = routeTime - normalTime + Lua_JumpGameDebugWindow.Action_Jump_Sky_Origin_Time;
		if skyTime > 0 then -- 空中循环
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Up_To_Sky);
			self.actionTimeArr:add(skyTime);

			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Sky_To_Down);
			self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Down_Time);
		else
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Up_To_Down);
			self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Down_Time);
		end

		local isSuccess = false;
		local dis = Vector2.Distance(self.targetJumpPos, self.curGridPos);
		if dis <= self._curGridSize then -- 还在当前格子
			isSuccess = true;
		else
			dis = Vector2.Distance(self.targetJumpPos, self.nextGridPos);
			if dis <= self._nextGridSize then -- 目标格子上
				isSuccess = true;
			end
		end

		self.tipsStr = self.tipsStr .. "\n跳跃目标点：" .. string.format("%.2f", self.targetJumpPos.x) .. "  ,  " .. string.format("%.2f", self.targetJumpPos.y);
		self.tipsStr = self.tipsStr .. "\n跳跃控制点：" .. string.format("%.2f", self.jumpControllPos.x) .. "  ,  " .. string.format("%.2f", self.jumpControllPos.y);
		self.tipsStr = self.tipsStr .. "\n跳跃路径时长：" .. string.format("%.2f", routeTime);
		self.tipsStr = self.tipsStr .. "\n跳跃结果：" .. (isSuccess and "成功" or "失败");
		self.tipsTxt.text = self.tipsStr;

		if isSuccess then -- 成功
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Down_To_Success);
			self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Success_Time);
		else -- 失败	
			self.actionArr:add(Lua_JumpGameDebugWindow.Action_Down_To_Fail);
			self.actionTimeArr:add(Lua_JumpGameDebugWindow.Action_Jump_Fail_Time);
		end
	end

	self._bplayingJump = true;
	self.jumpRouteTime = routeTime;
	self.delayRefreshNextTime = 1;
	self.modelImgVec = Vector3.New(); 
	self.lastPlayingJumpTime = getTime();
	self.startPlayingJumpTime = getTime();
	self.modelItem:setAction(self.actionArr[1], -1);
	self.tipsStr = self.tipsStr .. "\n播放" .. self:getActionName(self.actionArr[1]) .. "(" .. self.actionArr[1] .. ")动作，当前跳跃时长：0" .. "，动作时长：" .. string.format("%.2f", self.actionTimeArr[1]);
	self.tipsTxt.text = self.tipsStr;
	-- self:addTimer("Lua_JumpGameDebugWindow_playingJump", 0.01, self, self.onPlayingJumpTimer, nil, -1);
	self:startModelMove();
end

function Lua_JumpGameDebugWindow:startModelMove()
	if self._bModelMove ~= true then
		self._bModelMove = true; 

		self:addTimer("Lua_JumpGameDebugWindow_playingJump", 0.01, self, self.onPlayingJumpTimer, nil, -1, true);
		self:onPlayingJumpTimer();
	end
end

function Lua_JumpGameDebugWindow:endModelMove()
	if self._bModelMove then
		self._bModelMove = false;
		self:removeTimer(self, self.onPlayingJumpTimer);
	end
end

-- 模型动作结束帧
function Lua_JumpGameDebugWindow:onModelAniComplete(endAct, endActName)
	print("onModelAniComplete", endAct);
	-- if endAct == self.actionArr[1] then
	-- 	self.actionArr:remove(1);
	-- 	self.actionTimeArr:remove(1);
	-- 	if self.actionTimeArr:getSize() > 0 then
	-- 		self.modelItem:setAction(self.actionArr[1], -1);
	-- 		local at = self.actionTimeArr[1];
	-- 		local t = getTime();
	-- 		local jumpTime = t - self.startPlayingJumpTime;
	-- 		if at > 0 and self.actionArr[1] == Lua_JumpGameDebugWindow.Action_Down_To_Fail then -- 失败渐变
	-- 			TweenUtil.getInstance():stop(self.modelItem);
	-- 			TweenUtil.getInstance():addTweenTargetAlpha(self.modelItem.mainContent, 0.6, at - 0.6, -1, false);
	-- 		end
	-- 		self.tipsStr = self.tipsStr .. "\n播放" .. self:getActionName(self.actionArr[1]) .. "(" .. self.actionArr[1] .. ")动作，当前跳跃时长：" .. string.format("%.2f", jumpTime) .. "，动作时长：" .. string.format("%.2f", self.actionTimeArr[1]);
	-- 		self.tipsTxt.text = self.tipsStr;
	-- 	end
	-- end
end

function Lua_JumpGameDebugWindow:onPlayingJumpTimer()
	local actEnd = false;
	local t = getTime();
	local jumpTime = t - self.startPlayingJumpTime;
	local dt = t - self.lastPlayingJumpTime;
	self.lastPlayingJumpTime = t;
	-- if self.actionArr[1] == Lua_JumpGameDebugWindow.Action_Up_To_Sky then
		if self.actionTimeArr:getSize() > 0 then
			local at = self.actionTimeArr[1];
			at = at - dt;
			self.actionTimeArr[1] = at;
			while (at <= 0 and self.actionTimeArr:getSize() > 0) do
				self.actionArr:remove(1);
				self.actionTimeArr:remove(1);
				if self.actionTimeArr:getSize() > 0 then
					at = at + self.actionTimeArr[1];
					self.actionTimeArr[1] = at;
					self.modelItem:setAction(self.actionArr[1], -1);
					if at > 0 and self.actionArr[1] == Lua_JumpGameDebugWindow.Action_Down_To_Fail then -- 失败渐变
						TweenUtil.getInstance():stop(self.modelItem);
						TweenUtil.getInstance():addTweenTargetAlpha(self.modelItem.mainContent, 0.6, at - 0.6, -1, false);
					end
					self.tipsStr = self.tipsStr .. "\n播放" .. self:getActionName(self.actionArr[1]) .. "(" .. self.actionArr[1] .. ")动作，当前跳跃时长：" .. string.format("%.2f", jumpTime) .. "，动作时长：" .. string.format("%.2f", self.actionTimeArr[1]);
					self.tipsTxt.text = self.tipsStr;
				end
			end

			actEnd = at <= 0;
			if actEnd then
				self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Idle, -1);
				self.tipsStr = self.tipsStr .. "\n动作播放结束，当前跳跃时长：" .. string.format("%.2f", jumpTime);
				self.tipsTxt.text = self.tipsStr;
			end
		else
			actEnd = true;
		end
	-- elseif self.actionTimeArr:getSize() <= 0 then
	-- 	actEnd = true;
	-- end

	-- 浣熊轨迹运动
	local r = jumpTime / self.jumpRouteTime;
	if r > 1 then r = 1; end
	Lua_BezierUtils.Calculate2DimensionalBezierPoint(r, self.curModelPos, self.jumpControllPos, self.targetJumpPos, self.modelImgVec);
	self.modelItem:setLocation(self.modelImgVec.x, self.modelImgVec.y);
	
	if actEnd and jumpTime >= self.jumpRouteTime then -- 结束
		if self.delayRefreshNextTime > 0 then
			if self.delayRefreshNextTime == 1 then
				self.tipsStr = self.tipsStr .. "\n跳跃结束";
				self.tipsTxt.text = self.tipsStr;
			end

			self.delayRefreshNextTime = self.delayRefreshNextTime - dt;
			return;
		end

		self._bplayingJump = false;
		TweenUtil.getInstance():stop(self.modelItem);
		self.modelItem.alpha = 1;
		-- self:removeTimer(self, self.onPlayingJumpTimer);
		self:endModelMove();
		self.modelItem:setAction(Lua_JumpGameDebugWindow.Action_Idle, -1); -- 回到待机
		if self.circleBox.selected then -- 循环
			self.modelItem:setLocation(self.curModelPos.x, self.curModelPos.y);
			self:imitateJumpOperate();
		else -- 根据规则生成下一个格子
			self.pressTime = self._imitateTime / 30;
			local isSuccess = 0;
			local dis = Vector2.Distance(self.targetJumpPos, self.curGridPos);
			if dis <= self._curGridSize then -- 还在当前格子
				isSuccess = 1;
			else
				dis = Vector2.Distance(self.targetJumpPos, self.nextGridPos);
				if dis <= self._nextGridSize then -- 目标格子上
					isSuccess = 2;
				end
			end

			if isSuccess > 0 then
				self.curModelPos:Set(self.targetJumpPos.x, self.targetJumpPos.y);
				-- 跳到了下个格子才需要重新生成
				if isSuccess == 2 then -- 目标格子
					self.curGridPos:Set(self.nextGridPos.x, self.nextGridPos.y);
					if self.dirType == Lua_JumpGameDebugWindow.Grid_Random then
						self.dir = (Mathf.Random(0, 100) > 50) and Lua_JumpGameDebugWindow.Grid_Right or Lua_JumpGameDebugWindow.Grid_Lift;
						self.bLeft = self.dir == Lua_JumpGameDebugWindow.Grid_Lift;
					end
				end
			end

			self:refreshCurGrid();
			self:refreshModelDir();
			self:refreshNextGrid();
			self:generateAssist();
		end
	end
end

function Lua_JumpGameDebugWindow:getActionName(act)
	if act == nil then 
		return "";
	end

	if act == Lua_JumpGameDebugWindow.Action_Idle then
		return "待机";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Pre then
		return "下蹲";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Ready or act == Lua_JumpGameDebugWindow.Action_Pre_To_Ready then
		return "蓄力";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Up or act == Lua_JumpGameDebugWindow.Action_Pre_To_Up or act == Lua_JumpGameDebugWindow.Action_Ready_To_Up then
		return "起跳";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Sky or act == Lua_JumpGameDebugWindow.Action_Up_To_Sky then
		return "空中循环";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Down or act == Lua_JumpGameDebugWindow.Action_Up_To_Down or act == Lua_JumpGameDebugWindow.Action_Sky_To_Down then
		return "下落";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Success or act == Lua_JumpGameDebugWindow.Action_Down_To_Success then
		return "下落缓冲";
	end
	if act == Lua_JumpGameDebugWindow.Action_Jump_Fail or act == Lua_JumpGameDebugWindow.Action_Down_To_Fail then
		return "下落失败";
	end
	return "";
end