-- 战斗调试窗口
checkRequire("Lua_FightTemplateConfigData");
Lua_FightDebugWindow = class("Lua_FightDebugWindow", Lua_Window)
function Lua_FightDebugWindow:ctor()
	self:superCall("ctor");

	local arr = Lua_FightTemplateConfigData.getTestTempConfig();
	if arr ~= nil then
		self.h = 800 + Mathf.Ceil((arr:getSize() + 2) / 3) * 80;
	else
		self.h = 800;
	end
	self.w = 684;
	self.windowName = "Lua_FightDebugWindow";
	self.showBlackMask = false;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "xui_common_window_003";
	self.showClose = true;
	self.btnCloseAtlas = "common_altas_1";
	self.btnCloseSprite = "xui_common_button_001_n";
	self.showTitle = true;
	self.titleText = "战斗调试";
	self.titleNamePosY = self.h / 2 - 48;
	self.btnClosePosX = 296;
	self.btnClosePosY = self.h / 2 - 48;
end

function Lua_FightDebugWindow:buildShowItem()
	self:superCall("buildShowItem");
	LuaUtil.setRectSize(self.rectTf, self.w, self.h);

	local dx = 0;
	local dy = 0;
	local step = 0;
	local arr = Lua_FightTemplateConfigData.getTestTempConfig();
	if arr ~= nil and arr:getSize() > 0 then
		for i = 1, arr:getSize() do
			step = step + 1;
			dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
			dy = -55 - Mathf.Ceil(step / 3) * 60;
			local btn = UICreate.createButton(self.content, arr[i].title, dx, dy, 180, 54);
			btn:setStyle(14);
			btn.txt:setLocation(0, 0, 0);
			btn.txt.fontSize = 28;
			btn:addClickFuntion(self, self.onFightTest);
			btn.anchorValue = 1;
			btn.name = arr[i].id;
		end
	else
		step = step + 1;
		dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
		dy = -55 - Mathf.Ceil(step / 3) * 60;
		local btn = UICreate.createButton(self.content, "快速战斗", dx, dy, 180, 54);
		btn:setStyle(14);
		btn.txt:setLocation(0, 0, 0);
		btn.txt.fontSize = 28;
		btn:addClickFuntion(self, self.onFightTest);
		btn.anchorValue = 1;
		btn.name = "9999";
	end

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	btn = UICreate.createButton(self.content, "战斗自定义", dx, dy, 180, 54);
	btn:setStyle(14);
	btn.txt:setLocation(0, 0, 0);
	btn.txt.fontSize = 28;
	btn:addClickFuntion(self, self.onFightDebugTest);
	btn.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	btn = UICreate.createButton(self.content, "技能模板", dx, dy, 180, 54);
	btn:setStyle(14);
	btn.txt:setLocation(0, 0, 0);
	btn.txt.fontSize = 28;
	btn:addClickFuntion(self, self.onSkillDebugTest);
	btn.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	if DataCenter.fightData.bSaveFightData then
		self.btnSaveData = UICreate.createButton(self.content, "保存数据-关", dx, dy, 180, 54);
	else
		self.btnSaveData = UICreate.createButton(self.content, "保存数据-开", dx, dy, 180, 54);
	end
	self.btnSaveData:setStyle(14);
	self.btnSaveData.txt:setLocation(0, 0, 0);
	self.btnSaveData.txt.fontSize = 28;
	self.btnSaveData:addClickFuntion(self, self.onSaveData);
	self.btnSaveData.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	if DataCenter.fightData.bShowSkinBtn then
		self.btnShowSkin = UICreate.createButton(self.content, "跳过按钮-关", dx, dy, 180, 54);
	else
		self.btnShowSkin = UICreate.createButton(self.content, "跳过按钮-开", dx, dy, 180, 54);
	end
	self.btnShowSkin:setStyle(14);
	self.btnShowSkin.txt:setLocation(0, 0, 0);
	self.btnShowSkin.txt.fontSize = 28;
	self.btnShowSkin:addClickFuntion(self, self.onShowSkin);
	self.btnShowSkin.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	self.btnAnalysis = UICreate.createButton(self.content, "选择文件播放", dx, dy, 180, 54);
	self.btnAnalysis:setStyle(14);
	self.btnAnalysis.txt:setLocation(0, 0, 0);
	self.btnAnalysis.txt.fontSize = 28;
	self.btnAnalysis:addClickFuntion(self, self.onAnalysis);
	self.btnAnalysis.anchor = Lua_WindowUtil.getAnchor(1);

	local bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 100, 640, 550);
	bg.anchorValue = 7;
	bg.pivotValue = 7;
	bg.clickScale = false;
	bg.alpha = 0.5;

	local label = UICreate.createLabel(self.content, "调试ID：", -300, 686, 0, 0, 26);
	label.anchorValue = 7;
	label.horizontalOverflowValue = 1
	label.verticalOverflowValue = 1
	label.colorStr = Lua_ColorDefine.transColor("8F5123");

	local inputBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", -36, 686, 300, 50);
	inputBg.anchorValue = 7;
	inputBg.clickScale = false;
	inputBg.alpha = 0.5;

    self.debugInput = UICreate.createInput(self.content, nil, -36, 686, 280, 50, 31);
    self.debugInput.anchorValue = 7;
    self.debugInput.alignmentValue = 3;
    self.debugInput.colorStr = Lua_ColorDefine.transColor("8F5123");

   	btn = UICreate.createButton(self.content, "播放", 225, 686, 180, 54);
   	btn.anchorValue = 7;
	btn:setStyle(14);
	btn.txt:setLocation(0, 0, 0);
	btn.txt.fontSize = 28;
	btn:addClickFuntion(self, self.onDebugPlay);

	self.fightList = Lua_DragList.new(self.content, 640, 550, Lua_AxisDefine.Vertical);
	self.fightList:setListCell(Lua_DebugFightRecordItem, 640, 40, 1);
	self.fightList:setLocation(0, 100, 0);
	self.fightList:setRectAnchor(7);
	self.fightList:setRectPivot(7);

	self.debugList = Lua_DragList.new(self.content, 640, 550, Lua_AxisDefine.Vertical);
	self.debugList:setListCell(Lua_FightDebugRecordItem, 640, 80, 1);
	self.debugList:setLocation(0, 100, 0);
	self.debugList:setRectAnchor(7);
	self.debugList:setRectPivot(7);

	self.btnInfo = Array();
	self.btnInfo:add({ textStr = "战斗记录" })
	self.btnInfo:add({ textStr = "调试记录" })

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
	self.btnList:setRectAnchor(7)
	self.btnList:setLocation(0, 60, 0)
	self.btnList:setButtonItem(184, 62)
	self.btnList:setClickCallBack(self, self.onButtonClick)
	self.btnList:setData(self.btnInfo)
	self.btnList:setSelected(1)

	self:addCSharpEvent("SELECT_FILE", self, self.onFileSelected);
end

function Lua_FightDebugWindow:dispose()
	if self.fightList ~= nil then
		self.fightList:dispose();
		self.fightList = nil;
	end
	if self.debugList then
		self.debugList:dispose();
		self.debugList = nil;
	end
	self:superCall("dispose");
end

function Lua_FightDebugWindow:onButtonClick(index)
	if index == 1 then
		self.fightList:setEnable(true);
		self.debugList:setEnable(false);
		self:updateFightRecord();
		
		self:removeLuaEvent("FIGHT_DEBUG_LIST", self, self.updateDebugList);
		self:addLuaEvent("FIGHTPLAY_ENTER", self, self.updateFightRecord);
	else
		self.fightList:setEnable(false);
		self.debugList:setEnable(true);
		self:removeLuaEvent("FIGHTPLAY_ENTER", self, self.updateFightRecord);
		self:addLuaEvent("FIGHT_DEBUG_LIST", self, self.updateDebugList);
		local cmd = ProtoPublic_pb.Proto10111999();
		cmd.cmd_name = "fight_debug_list";
		sendMsg(10111999, cmd);
	end
end

function Lua_FightDebugWindow:onFightTest(obj)
	if obj ~= nil then
		local num = obj.name;
		if not strIsNullOrEmpty(num) then
			local cmd = ProtoPublic_pb.Proto10111999();
			cmd.cmd_name = "fight";
			cmd.param1 = tonumber(num);
			sendMsg(10111999, cmd);
			self:hide();
			return;
		end
	end

	GlobalVar.bFightDebug = true;
	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "fight";
	sendMsg(10111999, cmd);
	self:hide();
end

function Lua_FightDebugWindow:onSkillDebugTest()
	self:hide();
	Lua_WindowUtil.openWin("Lua_FightSkillDebugWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugWindow:onFightDebugTest()
	self:hide();
	Lua_WindowUtil.openWin("Lua_FightDebugEditWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugWindow:updateFightRecord()
	self.fightList:setArrayData(DataCenter.fightData.recordIdArr);
end

function Lua_FightDebugWindow:updateDebugList(msg)
	self.debugList:setArrayData(msg.save_list);
end

function Lua_FightDebugWindow:onSaveData()
	local bValue = DataCenter.fightData.bSaveFightData;
	DataCenter.fightData.bSaveFightData = not bValue;
	if DataCenter.fightData.bSaveFightData then
		self.btnSaveData.label = "保存数据-关";
	else
		self.btnSaveData.label = "保存数据-开";
	end
end

function Lua_FightDebugWindow:onShowSkin()
	local bValue = DataCenter.fightData.bShowSkinBtn;
	DataCenter.fightData.bShowSkinBtn = not bValue;
	if DataCenter.fightData.bShowSkinBtn then
		self.btnShowSkin.label = "跳过按钮-关";
	else
		self.btnShowSkin.label = "跳过按钮-开";
	end
end

function Lua_FightDebugWindow:onAnalysis()
	LuaUtil.selectFile("txt");
end

function Lua_FightDebugWindow:onDebugPlay(go)
	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "replay_fight_debug";
	cmd.param1 = tonumber(self.debugInput.text)
	sendMsg(10111999, cmd);
	Lua_WindowUtil.openWin("Lua_FightDebugWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FightDebugWindow:onFileSelected(path)
	local str = LuaUtil.readLocalFile(path);
	if strIsNullOrEmpty(str) then 
		return; 
	end

	local arr = string.split(str, "\n");
	local index = -1;
	for i = 1, arr:getSize() do
		if index > -1 then
			self:onAnalysisMsg(arr[i]);
		end
		if arr[i] == "消息号：" then
			index = i;
		end
	end
end

function Lua_FightDebugWindow:onAnalysisMsg(str)
	if strIsNullOrEmpty(str) then
		return;
	end

	local arr = string.split(str, ":");
	local msgId = tonumber(arr[1]);
	local msgStr = string.gsub(arr[2], "[\n]", "");
	msgStr = string.gsub(msgStr, "[\r]", "");
	local mp = LuaUtil.parseMsgString(msgId, msgStr);
	if mp == nil then
		return;
	end

	if msgId == 80102001 then
		local msg = ProtoPublic_pb.Proto80102001();
		msg:ParseFromString(mp.data);
		DataCenter.fightData:addFightRecord(msg, nil, true);
	else
		DataCenter.fightData:parseFightRecordSegentMsg(mp, nil, true);
	end
end









Lua_DebugFightRecordItem = class("Lua_DebugFightRecordItem", Lua_ListCell);
function Lua_DebugFightRecordItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_DebugFightRecordItem:buildShowItem()
    self:superCall("buildShowItem");

	self.recordTxt = UICreate.createLabel(self.content, nil, -300, 0, 0, 0, 26);
	self.recordTxt.pivot = UIUtils.Pivot.Left;
	self.recordTxt.horizontalOverflowValue = 1
	self.recordTxt.verticalOverflowValue = 1
	self.recordTxt:addClickFuntion(self, self.onPlayRecord);

	self.switchTxt = UICreate.createLabel(self.content, "播放", -110, 0, 0, 0, 26);
	self.switchTxt.pivot = UIUtils.Pivot.Left;
	self.switchTxt.horizontalOverflowValue = 1
	self.switchTxt:resetSize();
	self.switchTxt:addClickFuntion(self, self.onSwitchClick);

	self.lookTxt = UICreate.createLabel(self.content, "脚本查看", -20, 0, 0, 0, 26);
	self.lookTxt.pivot = UIUtils.Pivot.Left;
	self.lookTxt.horizontalOverflowValue = 1
	self.lookTxt:resetSize();
	self.lookTxt:addClickFuntion(self, self.onLookTxtClick);

	self.stateTxt = UICreate.createLabel(self.content, "状态查看", 115, 0, 0, 0, 26);
	self.stateTxt.pivot = UIUtils.Pivot.Left;
	self.stateTxt.horizontalOverflowValue = 1
	self.stateTxt:resetSize();
	self.stateTxt:addClickFuntion(self, self.onStateTxtClick);

	self.closeTxt = UICreate.createLabel(self.content, "关闭", 250, 0, 0, 0, 26);
	self.closeTxt.pivot = UIUtils.Pivot.Left;
	self.closeTxt.horizontalOverflowValue = 1
	self.closeTxt:resetSize();
	self.closeTxt:addClickFuntion(self, self.onCloseTxtClick);
end

function Lua_DebugFightRecordItem:dispose()
	self.data = nil;
	self.recordVo = nil;
    self:superCall("dispose");
end

function Lua_DebugFightRecordItem:setData(data)
	self.data = data;
	self.recordVo = DataCenter.fightData:getRecordVoById(data);
    if self.recordVo == nil then
        return;
    end

    self.recordTxt.text = self.recordVo.templateConfig.title;
    self.recordTxt:resetSize();

	local player = DataCenter.fightData:getFightPlayerById(data);
	if player == nil or player.isPlayEnd then
		self.switchTxt.text = "播放";
	elseif player.bStopPlay then
		self.switchTxt.text = "继续";
	else
		self.switchTxt.text = "暂停";
	end
end

function Lua_DebugFightRecordItem:onPlayRecord()
	if self.data == nil then
		return;
	end
	-- Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data);
	DataCenter.fightData:playRecordByFightId(self.data, false, true);
	Lua_WindowUtil.openWin("Lua_FightDebugWindow", Lua_WinParam.ACTION_CLOSE); 
end

function Lua_DebugFightRecordItem:onSwitchClick()
	local player = DataCenter.fightData:getFightPlayerById(self.data);
	if player == nil or player.isPlayEnd then
		self:onPlayRecord();
		self.switchTxt.text = "暂停";
	elseif player.bStopPlay then
		DataCenter.fightData:controllFightPlay(self.data, true);
		self.switchTxt.text = "暂停";
	else
		DataCenter.fightData:controllFightPlay(self.data, false);
		self.switchTxt.text = "继续";
	end
end

function Lua_DebugFightRecordItem:onLookTxtClick()
	if self.recordVo == nil then
		OperateAlert.show("没有该战斗记录："..self.data);
	else
		if self.recordVo.isComplete == false then
			OperateAlert.show(self.data.." 数据未下发完成");
		elseif self.recordVo:writeFightRecord() then
			OperateAlert.show("生成成功");
		end
	end
end

function Lua_DebugFightRecordItem:onCloseTxtClick()
	DataCenter.fightData:removeFight(self.data);
	self.switchTxt.text = "播放";
end

function Lua_DebugFightRecordItem:onStateTxtClick()
	Lua_WindowUtil.openWin("Lua_FightPlayerStateWindow", Lua_WinParam.ACTION_OPEN, self.data); 
end










Lua_FightDebugRecordItem = class("Lua_FightDebugRecordItem", Lua_DebugFightRecordItem);

function Lua_FightDebugRecordItem:setData(data)
	self.data = data;
	self.recordTxt.text = data.key.."\n"..data.value;

	local player = DataCenter.fightData:getFightPlayerById(data.key);
	if player == nil or player.isPlayEnd then
		self.switchTxt.text = "播放";
	elseif player.bStopPlay then
		self.switchTxt.text = "继续";
	else
		self.switchTxt.text = "暂停";
	end
end

function Lua_FightDebugRecordItem:onPlayRecord()
	if self.data == nil then
		return;
	end
	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "replay_fight_debug";
	cmd.param1 = tonumber(self.data.key)
	sendMsg(10111999, cmd);
	Lua_WindowUtil.openWin("Lua_FightDebugWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FightDebugRecordItem:onSwitchClick()
	local player = DataCenter.fightData:getFightPlayerById(self.data.key);
	if player == nil or player.isPlayEnd then
		self:onPlayRecord();
		self.switchTxt.text = "暂停";
	elseif player.bStopPlay then
		DataCenter.fightData:controllFightPlay(self.data.key, true);
		self.switchTxt.text = "暂停";
	else
		DataCenter.fightData:controllFightPlay(self.data.key, false);
		self.switchTxt.text = "继续";
	end
end

function Lua_FightDebugRecordItem:onLookTxtClick()
	local recordVo = DataCenter.fightData:getRecordVoById(self.data.key);
	if recordVo == nil then
		OperateAlert.show("没有该战斗记录："..self.data.key);
	else
		if recordVo.isComplete == false then
			OperateAlert.show(self.data.key.." 数据未下发完成");
		elseif recordVo:writeFightRecord() then
			OperateAlert.show("生成成功");
		end
	end
end

function Lua_FightDebugRecordItem:onCloseTxtClick()
	DataCenter.fightData:removeFight(self.data.key);
	self.switchTxt.text = "播放";
end

function Lua_FightDebugRecordItem:onStateTxtClick()
	Lua_WindowUtil.openWin("Lua_FightPlayerStateWindow", Lua_WinParam.ACTION_OPEN, self.data.key); 
end